Ruby - Bug #14260

test failure related with proc arity on 32-bit environment (e.g. Solaris 10 with 32-bit compile)
12/30/2017 04:23 PM - ngoto (Naohisa Goto)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 2.3: DONTNEED, 2.4: DONTNEED, 2.5:
DONE

Description

(0000 rs9358 [l0sparc [I Solaris 10 [l Oracle Developer Studio (Oracle Solaris Studio) 12.x [ 320000000000000
make test-all 00000000 failure 000000000000
@000 re1515 0000)

1) Failure:
TestLazyEnumeratorf#test_each_cons_limit [/XXXXX/test/ruby/test_lazy_enumerator.rb:548]:
<[[1l, 2], [2, 311> expected but was
<[[2, 31, [2, 3]]>.

2) Failure:
TestProc#test_bound_parameters [/XXXXX/test/ruby/test_proc.rb:1184]:
<[[:rest]]> expected but was
<[]>.

3) Failure:
TestEnumeratorf#test_cons [/XXXXX/test/ruby/test_enumerator.rb:118]:
<[[1i, 2, 31,
4) Failure:
TestEnumerator#test_slice [/XXXXX/test/ruby/test_enumerator.rb:113]:
<[ri, 2, 31, 1[4, 5, 61, [7, 8, 91, [10]]> expected but was
<[[10], [10], [10], [1011>.

oooo

6) Failure:
TestProc#test_arity2 [/XXXXX/test/ruby/test_proc.rb:439]:
<-1> expected but was
<0>.

7) Failure:
TestLazyEnumeratorf#test_each_slice_limit [/XXXXX/test/ruby/test_lazy_enumerator.rb:554]:
<[[1, 2], [3, 411> expected but was
<[[3, 4], [3, 4]1>.
00000000o0DooDooDoonD

(a0oo00oo00000000 unsigned int 00000cO000000000000000

max [ -1 0000 uNLIMITED_ARGUMENTS 000000000000000
000 unsigned int : 16 00 65535 D00000000000000000

00000 signed int 0000000000 65535 0000000000000000000000
doooooooooocioonoonoooooooonoooooooooon

arityll UNLIMITED_ARGUMENTS [ 0 0000000000000000
000Faiture0000000000

000e4000000000000 #else 000 int min, max; 000000000000000000000000Faire00000000
000gec 00 16 DOODDOODDOD -1 0ODOODOOODOOODOODDOODDOODOO0DOFaiure0000O0DOOODOODDOODDOODOOODOODD

—-—— internal.h (revision 61515)
+++ internal.h (working copy)
@@ -912,12 +912,12 @@

/* IFUNC (Internal FUNCtion) */

struct vm_ifunc_argc {

#if SIZEOF_INT * 2 > SIZEOF_VALUE

- int min: (SIZEOF_VALUE * CHAR_BIT) / 2;
int max: (SIZEOF_VALUE * CHAR_BIT) / 2;

+ signed int min: (SIZEOF_VALUE * CHAR_BIT) / 2;
+ signed int max: (SIZEOF_VALUE * CHAR_BIT) / 2;
felse

int min, max;
#endif
}i

000Failure0000000 sotaris 00000000032000000000000000000000000DDODOODOO0O0

0000000000000000000000000000000000000000unsigned int
[II]I]I]I]I][I[I[II]I]I]I][I[I[II]I]I]I]I][I[II]I]I]I]I][I[I[II]I]I]I][I[I[II]I]I]I]I][I[II]I]I]I][I[I[II]I]I]

Associated revisions

Revision 2adf28159308bd09fdaa92c019ce7ed15b7c94e4 - 12/30/2017 04:38 PM - ngoto (Naohisa Goto)
bit fields treating negative values should be declared as signed int
e internal.h (struct vm_ifunc_argc): Bit fields are unsigned by default.
For storing nagative values to bit fields, they must be declated as
signed int. Fix multiple test failure observed by 32-bit binaries

compiled with Oracle Developer Studio (Solaris Studio) 12.x on
Solaris 10 on sparc architecture. [Bug #14260]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@61518 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 2adf2815 - 12/30/2017 04:38 PM - ngoto (Naohisa Goto)
bit fields treating negative values should be declared as signed int
e internal.h (struct vm_ifunc_argc): Bit fields are unsigned by default.

For storing nagative values to bit fields, they must be declated as

signed int. Fix multiple test failure observed by 32-bit binaries

compiled with Oracle Developer Studio (Solaris Studio) 12.x on

Solaris 10 on sparc architecture. [Bug #14260]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@61518 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 70c59ba555d80e0d7{795¢c20cfa4974d822f2916 - 01/07/2018 10:25 PM - naruse (Yui NARUSE)
merge revision(s) 61518: [Backport #14260]

bit fields treating negative values should be declared as signed int

* internal.h (struct vm_ifunc_argc): Bit fields are unsigned by default.

For storing nagative values to bit fields, they must be declated as
signed int. Fix multiple test failure observed by 32-bit binaries
compiled with Oracle Developer Studio (Solaris Studio) 12.x on
Solaris 10 on sparc architecture. [Bug #14260]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@61660 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 70c59ba5 - 01/07/2018 10:25 PM - naruse (Yui NARUSE)
merge revision(s) 61518: [Backport #14260]

bit fields treating negative values should be declared as signed int

* internal.h (struct vm_ifunc_argc): Bit fields are unsigned by default.
For storing nagative values to bit fields, they must be declated as
signed int. Fix multiple test failure observed by 32-bit binaries
compiled with Oracle Developer Studio (Solaris Studio) 12.x on

Solaris 10 on sparc architecture. [Bug #14260]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_ 5@61660 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 12/30/2017 04:38 PM - ngoto (Naohisa Goto)
- Status changed from Open to Closed

Applied in changeset trunk|r61518.

bit fields treating negative values should be declared as signed int

e internal.h (struct vm_ifunc_argc): Bit fields are unsigned by default.
For storing nagative values to bit fields, they must be declated as
signed int. Fix multiple test failure observed by 32-bit binaries
compiled with Oracle Developer Studio (Solaris Studio) 12.x on
Solaris 10 on sparc architecture. [Bug #14260]

#2 - 12/31/2017 11:46 AM - nagachika (Tomoyuki Chikanaga)
- Backport changed from 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5: UNKNOWN to 2.3: DONTNEED, 2.4: DONTNEED, 2.5: REQUIRED

000 bit field 0 r59358 [(2017-07-18)000000000000 2.5 00 ReQUIRED 0OOOOOON

#3 - 12/31/2017 01:22 PM - shyouhei (Shyouhei Urabe)

000000O00O000DO0D unsigned int 00000cO00000O0O00OODOD

00000000oDO0O0cOononononobononononaD0non0noDoDODoDoDaDaDD0DODODoDoDonODaDa.

#4 - 12/31/2017 04:28 PM - ngoto (Naohisa Goto)

000000000000000 unsigned int 00000cOOOODOODOODOOOD

0000000000000cO0nnnoononnnnnnoononnnnnno0nonn0n0Do00000n0000O0000nnn0O0anY
00000000000000000000
0000 implementation-defined 00000000000000000000000000
1000000000000000cee 00 6.7.2.1 OOO000DDOOOO0O0

00000000: http:/en.cppreference.com/w/c/language/bit_field

Oracle Solaris Studio [ 1BM 000000000000int0 unsigned 0000000000000000000000000O0OODOD

Oracle: https://docs.oracle.com/cd/E19205-01/820-1209/bjayo/index.html

IBM: https://www.ibm.com/support/knowledgecenter/en/SSQ2R2_8.5.1/com.ibm.tpf.toolkit.compilers.doc/ref/langref zos/clrc03defbitf.htm

l00Gecell singed DOOOO0O0
https://redmine.ruby-lang.org/issues/14260
http://en.cppreference.com/w/c/language/bit_field
https://docs.oracle.com/cd/E19205-01/820-1209/bjayo/index.html
https://www.ibm.com/support/knowledgecenter/en/SSQ2R2_8.5.1/com.ibm.tpf.toolkit.compilers.doc/ref/langref_zos/clrc03defbitf.htm

https://gce.gnu.org/onlinedocs/gece-5.2.0/gec/Structures-unions-enumerations-and-bit-fields-implementation.html

0000000000000 Gee O oracle Developer Studio 00000000000000000000000000

#5 - 01/02/2018 06:59 AM - shyouhei (Shyouhei Urabe)

ngoto (Naohisa Goto) wrote:

0000000000000DD unsigned int 0O000cOOOODOODOODDOOD

a000000000000co0nnnnnonnaonnaoonnonnannnonnannnon0aOnnaO0nnoO0Na0nono0NannoonD,
0000000000000D00000D
0000 implementation-defined 00000000000000000000000000
0000000000000000cese OO e.7.2.1 00OODDOODOODODO

gooooooo: http://en.cppreference.com/w/c/language/bit_field

Oracle Solaris Studio I 1BM 000000000000intD unsigned 00000000000000000000000O0O0OO0OD

Oracle: https://docs.oracle.com/cd/E19205-01/820-1209/bjayo/index.html

IBM: https://www.ibm.com/support/knowledgecenter/en/SSQ2R2_8.5.1/com.ibm.tpf.toolkit.compilers.doc/ref/langref zos/clrc03defbitf.htm

000Gecll singed 0000000

https://gce.gnu.org/onlinedocs/gee-5.2.0/gec/Structures-unions-enumerations-and-bit-fields-implementation.html

0000000000000 Gee O oracle Developer Studio 00000000000000000000000000

00000000oDODoonoDODODODODODO00000DindD0000signedlunsignedl000O000O0O00000000000000ODODOD

#6 - 01/07/2018 10:25 PM - naruse (Yui NARUSE)
- Backport changed from 2.3: DONTNEED, 2.4: DONTNEED, 2.5: REQUIRED to 2.3: DONTNEED, 2.4: DONTNEED, 2.5: DONE

ruby_2 5 r61660 merged revision(s) 61518.
https://gcc.gnu.org/onlinedocs/gcc-5.2.0/gcc/Structures-unions-enumerations-and-bit-fields-implementation.html
http://en.cppreference.com/w/c/language/bit_field
https://docs.oracle.com/cd/E19205-01/820-1209/bjayo/index.html
https://www.ibm.com/support/knowledgecenter/en/SSQ2R2_8.5.1/com.ibm.tpf.toolkit.compilers.doc/ref/langref_zos/clrc03defbitf.htm
https://gcc.gnu.org/onlinedocs/gcc-5.2.0/gcc/Structures-unions-enumerations-and-bit-fields-implementation.html
http://www.tcpdf.org

